﻿using Ozeki.VoIP;
using Voice_IVR.Model.InputInterpreter;
using System.Collections.Concurrent;
using System.Collections.Generic;

namespace Voice_IVR.Model.IVRMenuElements
{
    /// <summary>
    /// TODO
    /// </summary>
    internal class SoftPhoneElement : BaseIVRMenuElement
    {
        

        public SoftPhoneElement(
            Dictionary<IPhoneCall, CallSoundEngine> soundEngines, 
            IInputInterpreter inputInterpreter = null)
            : base(soundEngines, inputInterpreter)
        {
        }

        public override void EngineExecute(IPhoneCall phoneCall)
        {
            PhoneCall = phoneCall;
            phoneCall.CallStateChanged += PhoneCallCallStateChanged;

            CallSoundEngine soundEngine = GetSoundEngine(phoneCall);
            if (soundEngine != null)
                soundEngine.Focus();

            ActivateInputInterpreter();
            IVREngine.OnEngineEvent("SoftPhone", phoneCall.DialInfo.UserName, "Start");
        }

        /// <summary>
        /// DeActivate of the engine
        /// </summary>
        public override void EngineStop()
        {
            DeActivateInputInterpreter();

            CallSoundEngine soundEngine = GetSoundEngine(PhoneCall);
            if (soundEngine != null)
                soundEngine.Defocus();

            PhoneCall.CallStateChanged -= PhoneCallCallStateChanged;
            IVREngine.OnEngineEvent("SoftPhone", PhoneCall.DialInfo.UserName, "Stop");
        }

        /// <summary>
        /// Handles the CallStateChanged event
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void PhoneCallCallStateChanged(object sender, VoIPEventArgs<CallState> e)
        {
            if (e.Item != CallState.InCall)
            {
                EngineStop();
                IVREngine.OnEngineEvent("WavePlayer", PhoneCall.DialInfo.UserName, "Hangup");
            }
        }

        #region Cloning

        public override object Clone()
        {
            BaseIVRMenuElement newWavePlayerElement = new SoftPhoneElement(ItsSoundEngines);

            BaseCloning(newWavePlayerElement);

            return newWavePlayerElement;
        }

        #endregion
    }
}