﻿using System;
using Ozeki.VoIP;

namespace Voice_IVR.Model.InputInterpreter
{
    #region InputInformation

    internal class InputinformationArgs : EventArgs
    {
        private readonly object data;

        public InputinformationArgs(object data)
        {
            this.data = data;
        }

        public object Data
        {
            get { return data; }
        }
    }

    #endregion

    internal interface IInputInterpreter : ICloneable
    {
        /// <summary>
        /// The input signal information.
        /// </summary>
        event EventHandler<InputinformationArgs> InputInformation;

        /// <summary>
        /// Start the current InputInterpreter.
        /// </summary>
        /// <param name="phoneCall"></param>
        void Start(IPhoneCall phoneCall);

        /// <summary>
        /// Stop the curren InputINterpreter.
        /// </summary>
        void Stop();
    }
}